<template>
  <div>
    <Map />
    <div class="wrapper--button py-5" style="margin-top:100px;">
      <Button class="px-10 py-2 rounded-md" main :on-click="nextStep">Pilih Lokasi</Button>
      <Button class="px-8 py-2" ghost :on-click="showCancelWarning">Batalkan</Button>
    </div>
  </div>
</template>

<script>
import formMixin from '~/components/Form/form-mixin';
import Map from '~/components/Form/Section1/map';
import { mapState } from 'vuex';
import SimpleVueValidator from 'simple-vue-validator';
const Validator = SimpleVueValidator.Validator;
export default {
  components: {
    Map,
  },
  mixins: [formMixin, SimpleVueValidator.mixin],
  computed: {
    ...mapState({
      clientLocation: state => state.clientInfo.location,
      defaultCenter: state => state.form.defaultCenter,
    }),
    lat: {
      get() {
        return this.$store.state.form.lat;
      },
      set(val) {
        return this.$store.commit('form/SET_LAT', val);
      },
    },
    lng: {
      get() {
        return this.$store.state.form.lng;
      },
      set(val) {
        return this.$store.commit('form/SET_LNG', val);
      },
    },
    address() {
      return this.$store.state.form.address;
    },
  },
  validators: {
    address(value) {
      return Validator.value(value).required();
    },
  },
  async mounted() {
    await this.$store.dispatch('clientInfo/fetchCurrentPosition');
    if (this.clientLocation === null) {
      this.lat = this.defaultCenter.lat;
      this.lng = this.defaultCenter.lng;
    } else {
      this.lat = this.clientLocation.lat;
      this.lng = this.clientLocation.lng;
    }
  },

  methods: {
    async validate() {
      const valid = await this.$validate();
      if (!valid) this.showFormNotComplete();
      return valid;
    },
    async nextStep() {
      if (await this.validate()) {
        this.$store.dispatch('form/switchActiveTab', 2);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.input-search {
  color: $black-alt;
}

.vue-map-container {
  height: 100%;
}
</style>
